{
See proge demonstreerib eri sortimisviise.
J. Pant, XI 1997.
}

program sortijad;
 const maxind=80;                     {massiivi pikkus}
 type et=char;                        {elemendi tp}
      it=1..maxind;                      {indeksite tp}
      jada=array[it] of et;

function ees(x,y:et):boolean;
 begin
  if x<y then ees:=true
   else ees:=false;
 end;

procedure vaheta(var x,y:et);
 var abi:et;
 begin
  abi:=x;
  x:=y;
  y:=abi;
 end;

function yhtib(x,y:et):boolean;
 begin
  if x=y then yhtib:=true
   else yhtib:=false;
  end;

procedure mullsort(var a:jada;alpiir,ylpiir:it);
 var jarg,pos:it;
     veel:boolean;
 begin
  jarg:=1;
  veel:=true;
  while (jarg<ylpiir) and veel do
   begin
    veel:=false;
    for pos:=alpiir to ylpiir do
     if ees(a[pos],a[pos+1]) then
      begin
       veel:=true;
       vaheta(a[pos],a[pos+1]);
      end;
     inc(jarg);
   end;
   for pos:= 1 to (ylpiir-alpiir+1) div 2 do vaheta(a[pos],a[ylpiir-pos+1]);
 end;


procedure valiksort(var a:jada; alpiir,ylpiir:it);
 var jarg,pos,min_pos:it;
 begin
  for jarg:=alpiir to pred(ylpiir) do
   begin
    min_pos:=jarg;
    for pos:=succ(jarg) to ylpiir do
     if ees(a[pos],a[min_pos]) then min_pos:=pos;
    vaheta(a[jarg],a[min_pos]);
   end;
 end;

procedure kiirsort(var a:jada;alpiir,ylpiir:it);
 var al,yl:it;
 begin
  al:=alpiir;
  yl:=ylpiir;
  while al<yl do
   begin                                          {yl-ga vasakule}
    while (ees(a[al],a[yl]) or yhtib(a[al],a[yl])) and (al<yl) do dec(yl);
    vaheta(a[al],a[yl]);
						  {al-ga paremale}
    while (ees(a[al],a[yl]) or yhtib(a[al],a[yl])) and (al<yl) do inc(al);
    vaheta(a[al],a[yl]);
   end;
  if alpiir<(al-1) then kiirsort(a,alpiir,al-1);  {sordime vasaku poole}
  if ylpiir>(yl+1) then kiirsort(a,yl+1,ylpiir);  {sordime parema poole}
 end;

procedure mod_kiirsort(var a:jada;alpiir,ylpiir:it);
 var al,yl,jarg:it;
 begin
  al:=alpiir;
  yl:=ylpiir;
  jarg:=succ(alpiir);
  while jarg<=yl do
   if ees(a[jarg],a[al])then
    begin
     vaheta(a[al],a[jarg]);
     inc(al);
     inc(jarg);
    end
    else
     if ees(a[al],a[jarg]) then
      begin
       vaheta(a[jarg],a[yl]);
       dec(yl);
      end
      else inc(jarg);
  if alpiir<(al-1) then mod_kiirsort(a,alpiir,al-1);  {sordime viksemad}
  if ylpiir>(yl+1) then mod_kiirsort(a,yl+1,ylpiir);  {sordime suuremad}
 end;

 {
 2.32
 2.35
 2.37
 2.43
 2.47
 }

var abi,valik:byte;
     a:jada;
begin
 randomize;
 repeat
  writeln(' See proge sordib eri meetodite abil 80-kohalise juhusliku thejada,');
  writeln(' mis on jrgmisel real. (J.Pant, XI 1997)');
  for abi:= 1 to maxind do
   begin
    a[abi]:=char(random(26)+65);
    write(a[abi]);
   end;
  writeln(' Vali sortmeetod:');
  writeln ('   0= Progest vlja! (exit)');
  writeln ('   1= Kiirsort.');
  writeln ('   2= Modifitseeritud kiirsort.');
  writeln ('   3= Mullsort.');
  writeln ('   4= Valiksort.');
  writeln;
  write ('Sisesta oma soov : ');
  readln (valik);
  case valik of
   0:;
   1:kiirsort(a,1,maxind);
   2:mod_kiirsort(a,1,maxind);
   3:mullsort(a,1,maxind);
   4:valiksort(a,1,maxind);
   end;
  if (valik<5) and (valik>0) then
   begin
    writeln('Sorditud thejada :');
    for abi:= 1 to maxind do write(a[abi]);
    writeln;
   end
   else writeln('Sellist sortviisi siin pole !');
 until valik=0;
end.
